require 'tk'

class Editor

def self.run
puts `simped.rb`
end

end
#_________________________________ Main Window ______________________________
root = TkRoot.new{title "File Viewer"}
root['geometry'] = '1540x700+1+1'
#root['resizable'] = false, false
#____________________ BUTTONS _____________________________________________
button = TkButton.new(root){
text "OK"
#command(Proc{myproc})
}

button_click = Proc.new{system 'notepad'}
button.command = button_click

#___________________ MENU________________________________________________
############# Methods & VARIABLES ###################
TkOption.add '*tearOff', 0
$filename =TkVariable.new
$newfilename =TkVariable.new
#___________________________________
newfile = Proc.new{$text.delete(1.0, 'end')}
#________________________
openfile = Proc.new{
$filename = Tk::getOpenFile()
$content = File.read($filename)
$text.delete(1.0, 'end')
$text.insert('end', $content)
}
#___________________________________
closefile = Proc.new{$text.delete(1.0, 'end')}
#____________________________________
savefile = Proc.new{
thetext = $text.get("1.0", 'end')
File.write($filename, thetext)
}
#____________________________________
savefileas = Proc.new{
thetext = $text.get("1.0", 'end')
$newfilename = Tk::getSaveFile('filetypes' => [["All Files", "."], ["Text Files", ".txt"]])
File.write($newfilename, thetext)
}
#____________________________________
exitapp = Proc.new{exit}
help = Proc.new{help_win}
#_______ HELP MENU _____________________
def help_win
  begin
	$win.destroy
  rescue
  end
  $win = TkToplevel.new{title "Help Window"}
  TkLabel.new($win){
    text " This is a simple text editor using Tcl/Tk widgets.
The menu allows opening an existing file on system.
It also allows creating a new file and saving it.
An opened file can be saved under the same name
or under a new different name"
  borderwidth 5
  font TkFont.new('times 16 bold')
  background  "yellow"
  relief    "groove" 
  justify  "left"  
 }.grid('row' => 0, 'column' => 0)
  TkButton.new($win) {
	text "OK"
	command "$win.destroy"
  }.grid('row' => 1, 'column' => 0)
end
###################### Menu ###################
file_menu = TkMenu.new(root)
helpMenu = TkMenu.new(root)
#______________________________
file_menu.add('command',
              'label'     => "New...",
              'command'   => newfile,
              'underline' => 0)
file_menu.add('command',
              'label'     => "Open...",
              'command'   => openfile,
              'underline' => 0)
file_menu.add('command',
              'label'     => 'Close',
              'command'   => closefile,
              'underline' => 0)
file_menu.add('separator')
file_menu.add('command',
              'label'     => "Save",
              'command'   => savefile,
              'underline' => 0)
file_menu.add('command',
              'label'     => "Save As...",
              'command'   => savefileas,
              'underline' => 5)
file_menu.add('separator')
file_menu.add('command',
              'label'     => "Exit",
              'command'   => exitapp,
              'underline' => 3)
helpMenu.add('command',
              'label'   => "Help",
              'command' => help,
              'underline' => 3)
#_________________________________________
menu_bar = TkMenu.new
menu_bar.add('cascade',
             'menu'  => file_menu,
             'label' => "File")
menu_bar.add('cascade',
             'menu' => helpMenu,
             'label' => "Help")

root.menu(menu_bar)
#____________________________ TEXT ______________________________________
$text = TkText.new(root) do
  width 100
  height 24
  background "black"
  foreground  "white"
  font TkFont.new('tahoma 16 normal')
  wrap 'word'
  insertbackground "yellow"
  insertwidth 30
  cursor  "hand2"
end
 
$text.focus
#________________ SCROLLBAR ____________________________________________
scrollbar = TkScrollbar.new(root){command proc{|*args| $text.yview(*args)}
}
$text.yscrollcommand(proc{|first, last| scrollbar.set(first, last)})
#________________ GEOMETRY _____________________________________________
$text.grid('row' => 0, 'column' => 0)
button.grid('row' =>0, 'column' => 0)
scrollbar.grid('row' => 0, 'column' => 1, 'sticky' => 'NS')
TkGrid.columnconfigure( root, 0, :weight => 1 )
TkGrid.rowconfigure( root, 0, :weight => 1 )
TkGrid.columnconfigure( $text, 0, :weight => 0 )
TkGrid.rowconfigure( $text, 0, :weight => 0)

###################### Show ####################################
Tk.mainloop
##########################################################